<template>
  <v-row justify="center" no-gutters>
    <v-card style="width: 100%">
      <v-toolbar style="position:relative" color="white" elevation="0">
        <v-spacer />
        <v-toolbar-title class="mt-5">
          <span class="primary--text">
            <v-icon large color="primary" class="mr-2 pb-1">mdi-file-outline</v-icon
            ><b>{{ type == 'add' ? 'Nova questão' : 'Editar questão' }}</b>
          </span>
        </v-toolbar-title>
        <v-spacer />
        <v-tooltip color="red" bottom>
          <template v-slot:activator="{ on }">
            <v-icon
              v-on="on"
              style="position:absolute; right: 15px"
              color="red"
              @click="handleClose"
              >mdi-close</v-icon
            >
          </template>
          <span><b>Fechar</b> janela</span>
        </v-tooltip>
      </v-toolbar>
      <!-- TABS -->
      <v-row class="mt-2" no-gutters justify="center">
        <v-btn :class="actualTab == 0 ? 'test' : ''" outlined elevation="0" @click="goToTab0" small>
          etapa 1
        </v-btn>
        <v-btn
          :disabled="
            !formData.questionType ||
              !formData.body ||
              !formData.title ||
              !formData.difficulty ||
              !formData.visibility ||
              !formData.area.length > 0
          "
          :class="actualTab == 1 ? 'test' : ''"
          class="mx-2"
          outlined
          elevation="0"
          small
          @click="goToTab1"
        >
          etapa 2
        </v-btn>
      </v-row>
      <!-- Adicionar ou editar: Dados Gerais -->
      <div v-if="actualTab == 0" class="scrollForm">
        <v-card-text class="px-8 pt-0 pb-0">
          <v-form ref="form" v-model="valid">
            <!-- Adicionar novo usuario no banco de dados -->
            <v-container>
              <b style="font-size: 1.1rem" class="primary--text">Etapa 1 - Dados Gerais</b>
              <v-row>
                <v-col cols="12" sm="12" md="12" class="pt-0">
                  <v-text-field
                    autofocus
                    v-model="formData.title"
                    label="Título*"
                    required
                    prepend-icon="mdi-pencil-outline"
                  ></v-text-field>
                </v-col>
                <!-- <v-col cols="12" sm="12" md="6" class="pt-0">
                  <v-text-field
                    v-model="formData.author"
                    label="Autor*"
                    required
                    prepend-icon="mdi-account-outline"
                  ></v-text-field>
                </v-col> -->
                <v-col cols="12" class="pb-0">
                  <v-textarea
                    outlined
                    v-model="formData.body"
                    prepend-icon="mdi-file-outline"
                    class="ma-0 pa-0"
                    label="Enunciado"
                  ></v-textarea>
                </v-col>
                <v-col cols="12" sm="12" md="6" class="pt-0">
                  <v-select
                    prepend-icon="mdi-form-select"
                    v-model="formData.difficulty"
                    label="Selecione a dificuldade"
                    flat
                    hide-no-data
                    hide-details
                    item-text="name"
                    item-value="value"
                    :items="difficulty"
                  ></v-select>
                </v-col>
                <v-col cols="12" sm="12" md="6" class="pt-0">
                  <v-select
                    :disabled="type == 'edit'"
                    prepend-icon="mdi-file-document-edit-outline"
                    v-model="formData.questionType"
                    label="Tipo de questão"
                    flat
                    hide-no-data
                    hide-details
                    item-text="name"
                    item-value="value"
                    :items="questionType"
                    @input="changeTypeOfQuestion"
                  ></v-select>
                </v-col>
                <v-col cols="12" sm="12" md="6">
                  <v-combobox
                    prepend-icon="mdi-cube-outline"
                    v-model="selectedArea"
                    label="Selecione áreas p/ questão"
                    flat
                    hide-no-data
                    hide-details
                    item-text="name"
                    item-value="id"
                    :items="areas"
                  ></v-combobox>
                </v-col>
                <v-col cols="12" sm="12" md="6">
                  <v-select
                    prepend-icon="mdi-eye"
                    v-model="formData.visibility"
                    label="Selecione a visibilidade"
                    flat
                    hide-no-data
                    hide-details
                    item-text="name"
                    item-value="value"
                    :items="visibilityBox"
                  ></v-select>
                </v-col>
                <v-col v-if="selectedArea" cols="12" align-self="center" align="center">
                  <b>Confirmação de área:</b>
                  {{ selectedArea !== '' ? `${selectedArea.name}` : 'Vazia' }}
                  <v-tooltip v-if="selectedArea !== ''" bottom color="green">
                    <template v-slot:activator="{ on }">
                      <v-icon v-on="on" color="green" small @click="addCategory"
                        >mdi-check-circle</v-icon
                      >
                    </template>
                    <span><b>Adicionar</b> essa área</span>
                  </v-tooltip>
                  <v-tooltip v-if="selectedArea !== ''" bottom color="red">
                    <template v-slot:activator="{ on }">
                      <v-icon v-on="on" color="red" small @click="removeCategory"
                        >mdi-close-circle</v-icon
                      >
                    </template>
                    <span><b>Cancelar</b></span>
                  </v-tooltip>
                </v-col>
                <v-col cols="12" class="mt-2">
                  <b>Áreas da questão:</b>
                  <span v-if="formData.area.length == 0" class="pl-2"
                    >A questão ainda não está classificada em nenhuma área.</span
                  >
                  <v-chip
                    v-for="(area, index) in formData.area"
                    :key="index"
                    class="px-2 ml-1"
                    small
                  >
                    {{ searchNameForChips(area) }}
                    <v-icon small class="ml-1" color="red" @click="deleteFromAddedArea(area, index)"
                      >mdi-close-circle</v-icon
                    >
                  </v-chip>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card-text>
      </div>
      <!-- ALTERNATIVAS-->
      <div v-if="actualTab == 1" class="scrollForm">
        <v-card-text class="px-8 pt-0 pb-0 mt-4">
          <b style="font-size: 1.1rem" class="primary--text">Etapa 2 - Selecionando alternativas</b
          ><br /><br />

          <b v-if="formData.questionType == 'objective'" class="mr-1 titleSize"
            >(QUESTÃO MULTIPLA ESCOLHA)</b
          >
          <b v-if="formData.questionType == 'multipleChoice'" class="mr-1"
            >(QUESTÃO MULTIPLA ESCOLHA MULTI-RESPOSTA)</b
          >
          <b v-if="formData.questionType == 'summation'" class="mr-1">(QUESTÃO SOMATÓRIO)</b>
          <b v-if="formData.questionType == 'trueOrFalse'" class="mr-1"
            >(QUESTÃO VERDADEIRO OU FALSO)</b
          >
          <b v-if="formData.questionType == 'dissertation'" class="mr-1">(QUESTÃO DISSERTATIVA)</b>
          <br />
          <b>{{ formData.body }}</b>
          <v-form ref="form" v-model="valid">
            <!-- Alternativas -->
            <v-container>
              <v-divider class="my-4" />
              <!-- ADD ALTERNATIVAS, VÁLIDAS PARA TODAS EXCETO AS DISSERTATIVAS -->
              <v-row no-gutters>
                <v-col cols="12" align="center" class="mb-4">
                  <v-btn
                    v-if="formData.questionType !== 'dissertation'"
                    color="grey lighten-2"
                    elevation="0"
                    @click="increaseNumberOfAlternatives"
                    small
                  >
                    Adicionar alternativa
                  </v-btn>
                  <v-btn
                    v-else
                    color="grey lighten-2"
                    elevation="0"
                    @click="increaseNumberOfAlternativesII"
                    small
                  >
                    Adicionar Respostas Corretas
                  </v-btn>
                </v-col>

                <v-col
                  v-for="(form, index) in alternatives"
                  :key="index"
                  cols="12"
                  class="ma-0 pa-0"
                >
                  <!-- PARA O MODO ADD -->
                  <v-row
                    v-if="type == 'add'"
                    no-gutters
                    :class="form.correct ? 'green lighten-4 px-4' : 'px-4'"
                    align="center"
                  >
                    <v-tooltip bottom color="green">
                      <template v-slot:activator="{ on }">
                        <v-btn
                          v-if="formData.questionType !== 'dissertation'"
                          x-small
                          v-on="on"
                          class="mr-2 px-0"
                          elevation="0"
                          color="transparent"
                          @click="handleRightAnswer(index)"
                        >
                          <v-icon v-if="formData.questionType == 'objective'" class="pa-0 ma-0">{{
                            form.correct ? 'mdi-radiobox-marked' : 'mdi-radiobox-blank'
                          }}</v-icon>
                          <span v-else>
                            <!-- para aparecer somatorio -->
                            <span
                              style="font-size: 0.8rem"
                              v-if="formData.questionType == 'summation'"
                              class="pr-1"
                            >
                              {{ Math.pow(2, index) }}
                            </span>
                            <v-icon class="pa-0 ma-0">{{
                              form.correct ? 'mdi-checkbox-marked' : 'mdi-checkbox-blank-outline'
                            }}</v-icon>
                          </span>
                        </v-btn>
                      </template>
                      <span><b>Marcar como resposta</b></span>
                    </v-tooltip>
                    <v-text-field
                      v-model="alternatives[index].text"
                      :label="
                        `${
                          formData.questionType !== 'dissertation' ? 'Alternativa' : 'Resposta'
                        } ${index + 1}`
                      "
                      required
                    ></v-text-field>
                    <v-tooltip bottom color="red">
                      <template v-slot:activator="{ on }">
                        <v-icon
                          v-on="on"
                          color="red"
                          small
                          @click="removeNumberOfAlternatives(index)"
                          >mdi-close</v-icon
                        >
                      </template>
                      <span><b>Remover</b></span>
                    </v-tooltip>
                  </v-row>
                  <!-- PARA O MODO EDIT -->
                  <v-row
                    v-if="type == 'edit'"
                    no-gutters
                    :class="form.correct ? 'green lighten-4 px-4' : 'px-4'"
                    align="center"
                  >
                    <v-tooltip bottom color="green">
                      <template v-slot:activator="{ on }">
                        <v-btn
                          :disabled="checkEditMode(form)"
                          v-if="formData.questionType !== 'dissertation'"
                          x-small
                          v-on="on"
                          class="mr-2 px-0"
                          elevation="0"
                          color="transparent"
                          @click="handleRightAnswer(index)"
                        >
                          <v-icon v-if="formData.questionType == 'objective'" class="pa-0 ma-0">{{
                            form.correct ? 'mdi-radiobox-marked' : 'mdi-radiobox-blank'
                          }}</v-icon>
                          <span v-else>
                            <!-- para aparecer somatorio -->
                            <span
                              style="font-size: 0.8rem"
                              v-if="formData.questionType == 'summation'"
                              class="pr-1"
                            >
                              {{ Math.pow(2, index) }}
                            </span>
                            <v-icon class="pa-0 ma-0">{{
                              form.correct ? 'mdi-checkbox-marked' : 'mdi-checkbox-blank-outline'
                            }}</v-icon>
                          </span>
                        </v-btn>
                      </template>
                      <span><b>Marcar como resposta</b></span>
                    </v-tooltip>
                    <v-text-field
                      :disabled="checkEditMode(form)"
                      v-model="alternatives[index].text"
                      :label="
                        `${
                          formData.questionType !== 'dissertation' ? 'Alternativa' : 'Resposta'
                        } ${index + 1}`
                      "
                      required
                    ></v-text-field>
                    <v-tooltip v-if="!checkEditMode(form)" bottom color="green">
                      <template v-slot:activator="{ on }">
                        <v-icon
                          v-on="on"
                          color="green"
                          small
                          class="mr-1"
                          @click="editIncreaseNumberOfAlternatives(form, index)"
                          >mdi-plus</v-icon
                        >
                      </template>
                      <span><b>Adicionar</b></span>
                    </v-tooltip>
                    <v-tooltip v-if="checkEditMode(form)" bottom color="red">
                      <template v-slot:activator="{ on }">
                        <v-icon
                          v-on="on"
                          color="red"
                          small
                          @click="editRemoveNumberOfAlternatives(form, index)"
                          >mdi-close</v-icon
                        >
                      </template>
                      <span><b>Remover</b></span>
                    </v-tooltip>
                    <v-tooltip v-else bottom color="red">
                      <template v-slot:activator="{ on }">
                        <v-icon
                          v-on="on"
                          color="red"
                          small
                          @click="removeNumberOfAlternatives(index)"
                          >mdi-close</v-icon
                        >
                      </template>
                      <span><b>Remover</b></span>
                    </v-tooltip>
                  </v-row>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card-text>
      </div>
      <!-- Botão Fechar -->
      <v-card-actions class="mt-n3 pb-6 pr-6">
        <v-spacer />
        <v-btn color="lighter" text @click="handleClose">Fechar</v-btn>
        <v-btn
          v-if="this.actualTab == 0"
          :disabled="
            !formData.questionType ||
              !formData.body ||
              !formData.title ||
              !formData.difficulty ||
              !formData.visibility ||
              !formData.area.length > 0
          "
          elevation="0"
          color="primary"
          class="px-4"
          @click="goToTab1"
          >{{ type == 'add' ? 'Avançar' : 'Salvar' }}</v-btn
        >
        <v-btn v-if="this.actualTab == 1" outlined elevation="0" class="px-4" @click="goToTab0"
          >Voltar</v-btn
        >
        <v-btn
          v-if="this.actualTab == 1 && type == 'add'"
          :disabled="checkAlternatives()"
          elevation="0"
          color="primary"
          class="px-4"
          @click="finishQuestion"
          >{{ type == 'add' ? 'Adicionar Questão' : 'Editar Questão' }}</v-btn
        >
      </v-card-actions>
    </v-card>
    <!-- Confirma deletar resposta -->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="editRemoveConfirm()"
    />
    <!-- Confirma add resposta -->
    <AlertConfirm
      :alert="alert2"
      @clickCancelAlert="alert2.status = false"
      @clickConfirmAlert="editAddConfirm()"
    />
    <!-- Confirma del categoria -->
    <AlertConfirm
      :alert="alert3"
      @clickCancelAlert="alert3.status = false"
      @clickConfirmAlert="deleteAreaBackend()"
    />
    <!-- Confirma add categoria -->
    <AlertConfirm
      :alert="alert4"
      @clickCancelAlert="alert4.status = false"
      @clickConfirmAlert="addAreaBackend()"
    />
  </v-row>
</template>

<script>
import Teacher from '../../../services/questionBank'

export default {
  name: 'ManageQuestion',
  props: {
    itemToEdit: { type: Object, default: {} },
    type: { type: String, default: 'add' },
    areas: {
      type: Array,
      default: () => {
        return []
      },
    },
  },
  data: () => ({
    valid: false,
    formData: {
      title: '',
      body: '',
      author: '',
      difficulty: '',
      public: '',
      visibility: '',
      area: [],
      questionType: '',
      correctAnswers: [],
      incorrectAnswers: [],
    },
    difficulty: [
      { name: 'Fácil', value: 'easy' },
      { name: 'Médio', value: 'medium' },
      { name: 'Difícil', value: 'hard' },
    ],
    questionType: [
      { name: 'Múltipla Escolha', value: 'objective' },
      { name: 'Múltipla Escolha Multi-Resposta', value: 'multipleChoice' },
      { name: 'Somatório', value: 'summation' },
      { name: 'Verdadeiro ou Falso', value: 'trueOrFalse' },
      { name: 'Dissertativa', value: 'dissertation' },
    ],
    numberOfAlternatives: 0,
    alternatives: [],
    correctAnswer: 'xxx',
    selectedArea: '',
    actualTab: 0,
    visibilityBox: [
      { name: 'Pública', value: 'public' },
      { name: 'Privado', value: 'private' },
    ],
    userInfo: {},
    alert: {
      status: false,
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    alert2: {
      status: false,
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    alert3: {
      status: false,
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    alert4: {
      status: false,
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    editDeleteAnswer: { content: {}, index: -1 },
    editAddAnswer: { content: {}, index: -1 },
    editAreaDelete: { id: '', index: -1 },
    editAreaToAdd: '',
    compareStatesToEdit: { title: '', body: '', visibility: '', difficulty: '' },
  }),
  watch: {
    'itemToEdit.id'() {
      this.editUpdate()
    },
  },
  async created() {
    // atualiza os dados ao criar o componente pela 1ªvez - editando
    this.editUpdate()
    // carrega dados
    this.userInfo = await this.$getItem('userInfo')
  },
  methods: {
    //frontend básico
    handleClose() {
      this.$emit('handleClose')
      this.resetData()
    },
    resetData() {
      this.formData = {
        title: '',
        body: '',
        author: '',
        difficulty: '',
        public: '',
        visibility: '',
        area: [],
        questionType: '',
        correctAnswers: [],
        incorrectAnswers: [],
      }
      this.alternatives = []
      this.actualTab = 0
      this.selectedArea = ''
    },

    addCategory() {
      let toAdd = this.selectedArea.id
      let check = 0

      this.formData.area.forEach((areaId) => {
        if (toAdd == areaId || toAdd == areaId.id) check++
      })

      if (check == 0) {
        if (this.type == 'add') {
          this.formData.area.push(toAdd)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Área <b>adicionada</b> a questão!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }

        if (this.type == 'edit') {
          this.editAreaToAdd = toAdd
          this.alert4.status = true
          this.alert4.icon = 'mdi-help-rhombus'
          this.alert4.message = 'Deseja <b>adicionar</b> uma <b>nova categoria</b> a pergunta?'
        }
      } else {
        this.$store.commit('user/UPDATE_ALERT', {
          status: true,
          message: 'A área selecionada <b>já foi adicionada</b> a questão.',
          icon: 'mdi-alert',
          color: 'test',
        })
      }
    },

    async addAreaBackend() {
      let teacherId = this.userInfo.document.documentNumber
      if (this.itemToEdit.author) teacherId = this.itemToEdit.author.document
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Teacher.editAddArea(teacherId, this.itemToEdit.id, [this.editAreaToAdd])
        if (req.success) {
          this.formData.area.push(this.editAreaToAdd)
          this.alert4.status = false
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Categoria foi <b>adicionada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          this.$emit('editQuestion')
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    removeCategory() {
      this.selectedArea = ''
    },

    searchNameForChips(item) {
      for (let i = 0; i < this.areas.length; i++) {
        if (this.areas[i].id == item || this.areas[i].id == item.id) return this.areas[i].name
      }
      return 'noName'
    },

    deleteFromAddedArea(area, indexToDelete) {
      if (this.type == 'add') this.formData.area.splice(indexToDelete, 1)
      else {
        this.alert3.status = true
        this.alert3.icon = 'mdi-help-rhombus'
        this.alert3.message = 'Deseja <b>deletar</b> a categoria selecionada?'
        this.editAreaDelete.index = indexToDelete
        this.editAreaDelete.id = area
      }
    },

    async deleteAreaBackend() {
      console.log(this.itemToEdit, 'AQUIIIIIIIIIII')
      let teacherId = this.userInfo.document.documentNumber
      if (this.itemToEdit.author) teacherId = this.itemToEdit.author.document
      console.log(teacherId, 'mostraaaaaxxx')
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Teacher.editRemoveArea(teacherId, this.itemToEdit.id, [
          this.editAreaDelete.id,
        ])
        if (req.success) {
          this.alert3.status = false
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Categoria foi <b>deletada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          this.formData.area.splice(this.editAreaDelete.index, 1)
          this.$emit('editQuestion')
        } else {
          this.alert3.status = false
          if (
            req.data.description ==
            "We didn't find an answer to error cannotRemoveAllAreas on model question"
          ) {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: 'Não é possivel <b>deletar a única</b> categoria da pergunta.',
              icon: 'mdi-close-circle',
              color: 'red',
            })
          }
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    goToTab0() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.actualTab = 0
        this.$store.commit('user/UPDATE_LOADING', false)
      }, 150)
    },

    async goToTab1() {
      this.$store.commit('user/UPDATE_LOADING', true)
      if (this.type == 'add')
        setTimeout(() => {
          this.actualTab = 1
          this.$store.commit('user/UPDATE_LOADING', false)
        }, 150)

      if (this.type == 'edit') {
        let update = {
          title: this.formData.title,
          body: this.formData.body,
          visibility: this.formData.visibility,
          difficulty: this.formData.difficulty,
        }

        let check = 0
        if (update.title !== this.compareStatesToEdit.title) check++
        if (update.body !== this.compareStatesToEdit.body) check++
        if (update.visibility !== this.compareStatesToEdit.visibility) check++
        if (update.difficulty !== this.compareStatesToEdit.difficulty) check++

        if (check > 0) {
          // let teacherId = this.userInfo.id
          // if (this.itemToEdit.author) teacherId = this.itemToEdit.author.id
          console.log(this.itemToEdit, 'editnado')

          let teacherId = this.itemToEdit.author.document

          try {
            let req = await Teacher.updateQuestion(teacherId, this.itemToEdit.id, update)
            if (req.success) {
              this.$emit('editQuestion')
              this.actualTab = 1 // retirada provisória
              this.compareStatesToEdit = JSON.parse(JSON.stringify(this.formData))
            }
          } catch (e) {
            console.error(e)
          } finally {
            this.$store.commit('user/UPDATE_LOADING', false)
          }
        } else {
          setTimeout(() => {
            this.actualTab = 1 // retirada provisória
            this.$store.commit('user/UPDATE_LOADING', false)
          }, 150)
        }
      }
    },

    changeTypeOfQuestion() {
      if (this.alternatives.length > 0)
        this.alternatives.forEach((answer) => {
          answer.correct = false
        })
      if (this.formData.questionType == 'dissertation') this.alternatives = []
    },
    //criando questões
    increaseNumberOfAlternatives() {
      this.numberOfAlternatives++
      this.alternatives.push({ text: '', correct: false })
    },

    //esse método é para questão dissertativa
    increaseNumberOfAlternativesII() {
      this.numberOfAlternatives++
      this.alternatives.push({ text: '', correct: true })
    },

    removeNumberOfAlternatives(index) {
      this.numberOfAlternatives--
      this.alternatives.splice(index, 1)
    },

    //ao clicar na alternativa para marcar certa/errada
    handleRightAnswer(indexData) {
      this.alternatives.forEach((answers, index) => {
        if (index == indexData) {
          answers.correct = !answers.correct
        } else {
          if (this.formData.questionType == 'objective') answers.correct = false
        }
      })
    },

    //métodos para atualizar interface quando estiver no método de "editar"
    editUpdate() {
      if (this.type == 'edit') {
        let edit = JSON.parse(JSON.stringify(this.itemToEdit))
        this.formData.title = edit.title
        this.formData.body = edit.body
        if (this.formData.author) this.formData.author = edit.author.name
        this.formData.difficulty = edit.difficulty
        this.formData.visibility = edit.visibility
        this.formData.questionType = edit.questionType
        this.formData.area = edit.area
        let incorretas, corretas

        if (edit.questionType !== 'dissertation') {
          incorretas = edit.incorrectAnswers
          incorretas.forEach((item) => {
            item.correct = false
          })

          corretas = edit.correctAnswers
          corretas.forEach((item) => {
            item.correct = true
          })

          this.alternatives = [...incorretas, ...corretas]
        } else {
          let corretas = edit.correctAnswers
          corretas.forEach((item) => {
            item.correct = true
          })

          this.alternatives = [...corretas]
        }

        if (edit.questionType == 'summation') {
          this.alternatives.sort((a, b) => {
            return a.order > b.order ? 1 : b.order > a.order ? -1 : 0
          })
        }

        this.compareStatesToEdit = this.itemToEdit
      }
    },

    //checar editar
    checkEditMode(item) {
      if (item._id) return true
      return false
    },

    //método para checar que foi adicionado alguma alternativa a questao
    checkAlternatives() {
      //checa se tem alternativas
      if (this.alternatives.length == 0) return true

      //checa se as alternativas tem texto
      let emptyAlternative = 0
      this.alternatives.forEach((alternative) => {
        if (!alternative.text) emptyAlternative++
      })
      if (emptyAlternative > 0) return true

      //checa se pelo menos 1 alternativa é marcada como correta
      let hasCorrect = 0
      this.alternatives.forEach((alternative) => {
        if (alternative.correct) hasCorrect++
      })
      if (hasCorrect == 0) return true

      return false
    },

    //método ao finalizar a edição ou uma nova questão
    finishQuestion() {
      this.alternatives.forEach((answer, index) => {
        if (answer.correct) {
          if (this.formData.questionType == 'summation') answer.order = index
          this.formData.correctAnswers.push(answer)
        } else {
          if (this.formData.questionType == 'summation') answer.order = index
          this.formData.incorrectAnswers.push(answer)
        }
      })
      if (this.type == 'add') this.$emit('addQuestion', this.formData)
      // if (this.type == 'edit') this.$emit('editQuestion', this.formData)
      this.handleClose()
    },

    // MODOEDIT BACKEND feito nesse componente mesmo, logo abaixo

    //adicionar resposta

    editIncreaseNumberOfAlternatives(form, index) {
      this.alert2.status = true
      this.alert2.icon = 'mdi-file-outline'
      this.alert2.message = `Você deseja <b>adicionar</b> essa resposta a pergunta?`
      this.editAddAnswer.content = form
      this.editAddAnswer.index = index
    },

    async editAddConfirm() {
      let form = this.editAddAnswer.content
      let index = this.editAddAnswer.index
      let answers = { correctAnswers: [], incorrectAnswers: [] }

      if (this.itemToEdit.questionType == 'summation') {
        if (form.correct) answers.correctAnswers.push({ text: form.text, order: index })
        else answers.incorrectAnswers.push({ text: form.text, order: index })
      } else {
        if (form.correct) answers.correctAnswers.push({ text: form.text })
        else answers.incorrectAnswers.push({ text: form.text })
      }

      try {
        let teacherId = this.userInfo.document.documentNumber
        if (this.itemToEdit.author) teacherId = this.itemToEdit.author.document

        let newAnswers = {}
        if (answers.correctAnswers.length == 0)
          newAnswers.incorrectAnswers = answers.incorrectAnswers
        if (answers.incorrectAnswers.length == 0) newAnswers.correctAnswers = answers.correctAnswers

        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Teacher.editAddAnswer(teacherId, this.itemToEdit.id, newAnswers)
        if (req.success) {
          this.alert2.status = false
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Resposta foi <b>adicionada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })

          req.data.correctAnswers.forEach((answer) => {
            this.alternatives.forEach((item, index) => {
              if (item.text == answer.text && !item._id) {
                this.$set(this.alternatives, index, Object.assign(item, { _id: answer._id }))
              }
            })
          })

          req.data.incorrectAnswers.forEach((answer) => {
            this.alternatives.forEach((item, index) => {
              if (item.text == answer.text && !item._id) {
                this.$set(this.alternatives, index, Object.assign(item, { _id: answer._id }))
              }
            })
          })
          this.$emit('editQuestion')
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
        this.alert2.status = false
      }

      // this.numberOfAlternatives++
      // this.alternatives.push({ text: '', correct: false })
    },

    // deletar resposta
    editRemoveNumberOfAlternatives(form, index) {
      this.alert.status = true
      this.alert.message = `Você deseja deletar a resposta selecionada?`
      this.editDeleteAnswer.content = form
      this.editDeleteAnswer.index = index
    },

    async editRemoveConfirm() {
      let form = this.editDeleteAnswer.content
      let index = this.editDeleteAnswer.index

      try {
        let teacherId = this.userInfo.document.documentNumber
        if (this.itemToEdit.author) teacherId = this.itemToEdit.author.document

        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Teacher.editRemoveAnswer(teacherId, this.itemToEdit.id, [form._id])
        if (req.success) {
          this.numberOfAlternatives--
          this.alternatives.splice(index, 1)
          this.alert.status = false
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Resposta foi <b>deletada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          this.$emit('editQuestion')
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>

<style>
.titleSize {
  font-size: 0.95rem;
}
</style>
